## gdal 3.11.4+dfsg

=== frmts/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

set(FRMT_SOURCES gdalallregister.cpp)

get_cmake_property(_variableNames VARIABLES)
set(EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE "")
foreach (_variableName ${_variableNames})
    unset(MATCHED)
    string(REGEX MATCH "ADD_EXTERNAL_DEFERRED_PLUGIN_(.*)" MATCHED ${_variableName})
    if (NOT MATCHED)
        continue()
    endif()
    if (EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE STREQUAL "")
        set(EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE "// File generated by frmts/CMakeLists.txt. DO NOT EDIT !\nextern void DeclareExternalDeferredPlugins();\nvoid DeclareExternalDeferredPlugins()\n{\n")
    endif()
    string(APPEND EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE "    // Plugin ${CMAKE_MATCH_1}\n    extern void DeclareDeferred${CMAKE_MATCH_1}();\n    DeclareDeferred${CMAKE_MATCH_1}();\n")
    list(APPEND FRMT_SOURCES "${${_variableName}}")
endforeach()
if (NOT EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE STREQUAL "")
    string(APPEND EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE "}\n")
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/external_deferred_plugins.c" "${EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE}")
    list(APPEND FRMT_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/external_deferred_plugins.c")
endif()

add_library(gdal_frmts OBJECT ${FRMT_SOURCES})
if (NOT EXTERNAL_DEFERRED_PLUGINS_SOURCE_CODE STREQUAL "")
    target_compile_definitions(gdal_frmts PRIVATE -DHAVE_EXTERNAL_DEFERRED_PLUGINS)
endif()

include(GdalDriverHelper)
include(CMakeDependentOption)

# JPEG must be defined before GTiff
gdal_dependent_format(jpeg "JPEG image format" "GDAL_USE_JPEG OR GDAL_USE_JPEG_INTERNAL")

# base driver provide frmt core functions
gdal_optional_format(raw "Raw formats:EOSAT FAST Format, FARSITE LCP and Vexcel MFF2 Image")
# JPEG must be defined before GTiff

# Exception to the rule: enable the GTiff driver by default, even if
# GDAL_BUILD_OPTIONAL_DRIVERS=OFF.
if (NOT DEFINED GDAL_ENABLE_DRIVER_GTIFF AND
    DEFINED GDAL_BUILD_OPTIONAL_DRIVERS AND
    NOT GDAL_BUILD_OPTIONAL_DRIVERS AND
    (GDAL_USE_TIFF OR GDAL_USE_TIFF_INTERNAL) AND
    (GDAL_USE_GEOTIFF OR GDAL_USE_GEOTIFF_INTERNAL))
    message(WARNING "Enabling GDAL_ENABLE_DRIVER_GTIFF=ON, despite GDAL_BUILD_OPTIONAL_DRIVERS=OFF. You can of course override this choice by setting GDAL_ENABLE_DRIVER_GTIFF=OFF")
    option(GDAL_ENABLE_DRIVER_GTIFF "Set ON to build GeoTIFF image format format" ON)
endif()

gdal_dependent_format(gtiff "GeoTIFF image format" "GDAL_USE_TIFF OR GDAL_USE_TIFF_INTERNAL;GDAL_USE_GEOTIFF OR GDAL_USE_GEOTIFF_INTERNAL")
set_package_properties(TIFF PROPERTIES PURPOSE "gdal_GTIFF: GeoTIFF image format")
gdal_format(mem "Read/write data in Memory")

# Exception to the rule: enable the VRT driver by default, even if
# GDAL_BUILD_OPTIONAL_DRIVERS=OFF.
if (NOT DEFINED GDAL_ENABLE_DRIVER_VRT AND
    DEFINED GDAL_BUILD_OPTIONAL_DRIVERS AND
    NOT GDAL_BUILD_OPTIONAL_DRIVERS)
    message(WARNING "Enabling GDAL_ENABLE_DRIVER_VRT=ON, despite GDAL_BUILD_OPTIONAL_DRIVERS=OFF. You can of course override this choice by setting GDAL_ENABLE_DRIVER_VRT=OFF")
    option(GDAL_ENABLE_DRIVER_VRT "Set ON to build Virtual GDAL Datasets" ON)
endif()

gdal_optional_format(vrt "Virtual GDAL Datasets")
if (NOT GDAL_ENABLE_DRIVER_VRT)
    # Even if we don't enable the driver (Open method), we still need to compile
    # Most of it
    add_subdirectory(vrt)
endif()

# Note: derived is derived of vrt
gdal_optional_format(derived "Derived datasets")

gdal_optional_format(gti "GDAL Tile Index")

# default formats

if (CMAKE_BUILD_TYPE MATCHES "Debug" OR GDAL_ENABLE_DRIVER_NULL)
  gdal_optional_format(null "NULL dummy driver")
endif ()

gdal_optional_format(libertiff "GeoTIFF support through libertiff library")
gdal_optional_format(hfa "Erdas Imagine .img")
gdal_optional_format(nitf "National Imagery Transmission Format")
gdal_optional_format(gxf "GXF")
gdal_optional_format(aaigrid "Arc/Info ASCII Grid Format.")
gdal_optional_format(ceos "CEOS translator")
gdal_optional_format(ceos2 "ASI CEOS translator" DRIVER_NAME_OPTION "SAR_CEOS")
gdal_optional_format(dted "Military Elevation Data")
gdal_optional_format(jdem "JDEM driver")
gdal_optional_format(envisat "Envisat")
gdal_optional_format(l1b "NOAA Polar Orbiter Level 1b Data Set (AVHRR)")
gdal_optional_format(rs2 "RS2 -- RadarSat 2 XML Product")
gdal_optional_format(ilwis "Raster Map")
gdal_optional_format(rmf "RMF --- Raster Matrix Format")
gdal_optional_format(leveller "Daylon Leveller heightfield")
gdal_optional_format(srtmhgt "SRTM HGT File Read Support")
gdal_optional_format(idrisi "Idrisi Raster Format")
gdal_optional_format(gsg "Implements the Golden Software Surfer 7 Binary Grid Format.")
gdal_optional_format(ers "ERMapper .ERS")
gdal_optional_format(jaxapalsar "JAXA PALSAR Level 1.1 and Level 1.5 processed products support")
gdal_optional_format(dimap "SPOT Dimap Driver")
gdal_optional_format(gff "Ground-based SAR Applitcations Testbed File Format driver")
gdal_optional_format(cosar "COSAR -- TerraSAR-X Complex SAR Data Product")
gdal_optional_format(pds "USGS Astrogeology ISIS Cube (Version 2)")
gdal_optional_format(adrg "ADRG reader and ASRP/USRP Reader")
gdal_optional_format(coasp "DRDC Configurable Airborne SAR Processor (COASP) data reader")
gdal_optional_format(tsx "TerraSAR-X XML Product Support")
gdal_optional_format(terragen "Terragen&trade; Terrain File")
gdal_optional_format(msgn "Meteosat Second Generation (MSG) Native Archive Format (.nat)")
gdal_optional_format(til "EarthWatch .TIL Driver")
gdal_optional_format(northwood "NWT_GRD/NWT_GRC -- Northwood/Vertical Mapper File Format")
gdal_optional_format(saga "SAGA GIS Binary Driver")
gdal_optional_format(xyz "ASCII Gridded XYZ")
include(avif/driver_declaration.cmake)
gdal_dependent_format(heif "HEIF" "GDAL_USE_HEIF")
gdal_optional_format(esric "ESRI compact cache")
gdal_optional_format(hf2 "HF2/HFZ heightfield raster")
gdal_optional_format(kmlsuperoverlay "")
gdal_optional_format(ctg "CTG driver")
gdal_optional_format(zmap "ZMAP")
gdal_optional_format(ngsgeoid "NOAA NGS Geoid Height Grids")
gdal_optional_format(iris "IRIS driver")
gdal_optional_format(map "OziExplorer .MAP")
gdal_optional_format(cals "CALS type 1")
set_package_properties(TIFF PROPERTIES PURPOSE "gdal_CALS: CALS type 1 driver")
gdal_optional_format(safe "SAFE -- Sentinel-1 SAFE XML Product")
gdal_optional_format(sentinel2 "Driver for Sentinel-2 Level-1B, Level-1C and Level-2A products.")
gdal_optional_format(prf "PHOTOMOD Raster File")
gdal_optional_format(mrf "Meta raster format")
gdal_optional_format(wmts "OGC Web Map Tile Service")
gdal_optional_format(grib "WMO General Regularly-distributed Information in Binary form")
gdal_optional_format(bmp "Microsoft Windows Device Independent Bitmap")
gdal_optional_format(tga "TGA")
gdal_optional_format(stacta "STACTA")
gdal_optional_format(snap_tiff "SNAP TIFF")

gdal_optional_format(bsb "Maptech/NOAA BSB Nautical Chart Format")
gdal_dependent_format(aigrid "Arc/Info Binary Grid Format" "OGR_ENABLE_DRIVER_AVC")
gdal_optional_format(usgsdem "USGS ASCII DEM (and CDED)")
gdal_optional_format(airsar "AirSAR Polarimetric Format")
gdal_optional_format(pcidsk "PCI Geomatics Database File")
gdal_optional_format(sigdem "Scaled Integer Gridded DEM .sigdem Driver")
gdal_dependent_format(msg "Meteosat Second Generation" "GDAL_USE_PUBLICDECOMPWT")
gdal_optional_format(rik "RIK -- Swedish Grid Maps")
gdal_optional_format(stacit "STACIT")
gdal_optional_format(pdf "Geospatial PDF") # write only if none of GDAL_USE_POPPLER, GDAL_USE_PODOFO or GDAL_USE_PDFIUM
                                           # is set
gdal_optional_format(rcm "Radarsat Constellation Mission")
gdal_optional_format(gdalg "GDAL Streamed Algorithm Format")

# formats with external library dependency
gdal_dependent_format(png "PNG image format" "GDAL_USE_PNG OR GDAL_USE_PNG_INTERNAL")
gdal_dependent_format(gif "Graphics Interchange Format" "GDAL_USE_GIF OR GDAL_USE_GIF_INTERNAL")

gdal_dependent_format(wcs "OGC Web Coverage Service" "GDAL_USE_CURL")
gdal_dependent_format(http "HTTP driver" "GDAL_USE_CURL")

gdal_dependent_format(netcdf "NetCDF network Common Data Form" "GDAL_USE_NETCDF")
gdal_optional_format(zarr "ZARR")
gdal_dependent_format(daas "Airbus DS Intelligence Data As A Service(DAAS)" "GDAL_USE_CURL")
gdal_dependent_format(eeda "Earth Engine Data API" "GDAL_USE_CURL")
gdal_dependent_format(fits "FITS Driver" "GDAL_USE_CFITSIO")
gdal_dependent_format(hdf5 "Hierarchical Data Format Release 5 (HDF5)" "GDAL_USE_HDF5")
gdal_dependent_format(plmosaic "PLMosaic (Planet Labs Mosaics API)" "GDAL_USE_CURL")
gdal_dependent_format(wms "Web Map Services" "GDAL_USE_CURL")
gdal_dependent_format(ogcapi "OGCAPI" "GDAL_USE_CURL")
gdal_dependent_format(gta "Generic Tagged Arrays" "GDAL_USE_GTA")
gdal_dependent_format(webp "WebP" "GDAL_USE_WEBP")
gdal_dependent_format(hdf4 "Hierarchical Data Format Release 4 (HDF4)" "GDAL_USE_HDF4")
gdal_dependent_format(mbtiles "MBTile" "GDAL_USE_SQLITE3;OGR_ENABLE_DRIVER_GPKG;OGR_ENABLE_DRIVER_MVT")
gdal_dependent_format(postgisraster "PostGIS Raster driver" "GDAL_USE_POSTGRESQL")
gdal_dependent_format(dds "DirectDraw Surface" "GDAL_USE_CRNLIB")
gdal_dependent_format(kea "Kea" "GDAL_USE_KEA;GDAL_USE_HDF5")
include(openjpeg/driver_declaration.cmake)
include(tiledb/driver_declaration.cmake)
gdal_dependent_format(exr "EXR support via OpenEXR library" "GDAL_USE_OPENEXR")
gdal_dependent_format(pcraster "PCRaster CSF 2.0 raster file driver" "GDAL_USE_LIBCSF OR GDAL_USE_LIBCSF_INTERNAL")
gdal_dependent_format(jpegxl "JPEG-XL" "GDAL_USE_JXL")
gdal_dependent_format(basisu_ktx2 "Basis Universal and KTX2 texture formats" "GDAL_USE_BASISU")

# ######################################################################################################################
# driver with proprietary libraries Kakadu software SDK
include(jp2kak/driver_declaration.cmake)
gdal_dependent_format(jpipkak "JPIP Streaming" "GDAL_USE_KDU")
# LizardTech's decoding software development kit (DSDK)
include(mrsid/driver_declaration.cmake)
include(georaster/driver_declaration.cmake)
include(ecw/driver_declaration.cmake)

# Register all frmt drivers according to FRMT_<driver> flags
gdal_standard_includes(gdal_frmts)
add_dependencies(gdal_frmts generate_gdal_version_h)
if (ENABLE_GNM)
  target_compile_definitions(gdal_frmts PRIVATE -DGNM_ENABLED)
  target_include_directories(gdal_frmts PRIVATE $<TARGET_PROPERTY:gnm_frmts,SOURCE_DIR>)
endif ()
target_include_directories(
  gdal_frmts PRIVATE $<TARGET_PROPERTY:gdal_vrt,SOURCE_DIR> $<TARGET_PROPERTY:ogrsf_generic,SOURCE_DIR>)
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gdal_frmts>)
set_property(TARGET gdal_frmts PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})

=== gcore/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.
add_library(
  gcore OBJECT
  gdal_adbc.cpp
  gdalalgorithm.cpp
  gdalalgorithmregistry.cpp
  gdalopeninfo.cpp
  gdaldriver.cpp
  gdaldrivermanager.cpp
  gdaldataset.cpp
  gdalrasterband.cpp
  gdalrasterblock.cpp
  gdalcolortable.cpp
  gdalmajorobject.cpp
  gdaldefaultoverviews.cpp
  gdalpamdataset.cpp
  gdalpamrasterband.cpp
  gdaljp2metadata.cpp
  gdaljp2box.cpp
  gdalmultidomainmetadata.cpp
  gdal_rat.cpp
  gdal_rat_vat_dbf.cpp
  gdalpamproxydb.cpp
  gdalallvalidmaskband.cpp
  gdalnodatamaskband.cpp
  gdalnodatavaluesmaskband.cpp
  gdalproxydataset.cpp
  gdalproxypool.cpp
  gdaldefaultasync.cpp
  gdaldllmain.cpp
  gdalexif.cpp
  gdalgeorefpamdataset.cpp
  gdaljp2abstractdataset.cpp
  gdalvirtualmem.cpp
  gdaloverviewdataset.cpp
  gdalrescaledalphaband.cpp
  gdaljp2structure.cpp
  gdal_mdreader.cpp
  gdaljp2metadatagenerator.cpp
  gdalabstractbandblockcache.cpp
  gdalarraybandblockcache.cpp
  gdalhashsetbandblockcache.cpp
  gdalrelationship.cpp
  gdalsubdatasetinfo.cpp
  gdalorienteddataset.cpp
  gdalthreadsafedataset.cpp
  geoheif.cpp
  overview.cpp
  rasterio.cpp
  rawdataset.cpp
  gdalmultidim.cpp
  gdalmultidim_gridded.cpp
  gdalmultidim_gltorthorectification.cpp
  gdalmultidim_meshgrid.cpp
  gdalmultidim_subsetdimension.cpp
  gdalmultidim_rat.cpp
  gdalpython.cpp
  gdalpythondriverloader.cpp
  tilematrixset.cpp
  gdal_thread_pool.cpp
  nasakeywordhandler.cpp
  tiff_common.cpp
)

add_library(gcore_gdal_misc OBJECT gdal_misc.cpp)
gdal_standard_includes(gcore_gdal_misc)
add_dependencies(gcore_gdal_misc generate_gdal_version_h)
set_property(TARGET gcore_gdal_misc PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gcore_gdal_misc>)
target_link_libraries(gcore_gdal_misc PRIVATE PROJ::proj)
target_link_libraries(gcore PRIVATE PROJ::proj)

gdal_standard_includes(gcore)
target_compile_definitions(gcore PUBLIC $<$<CONFIG:DEBUG>:GDAL_DEBUG>)
if (USE_PRECOMPILED_HEADERS)
    target_precompile_headers(gcore REUSE_FROM gdal_priv_header)
endif()
add_dependencies(gcore generate_gdal_version_h)
target_compile_options(gcore PRIVATE ${GDAL_CXX_WARNING_FLAGS} ${WFLAG_OLD_STYLE_CAST} ${WFLAG_EFFCXX})
target_include_directories(
  gcore
  PRIVATE $<TARGET_PROPERTY:ogrsf_generic,SOURCE_DIR> $<TARGET_PROPERTY:gdal_MEM,SOURCE_DIR>
          $<TARGET_PROPERTY:gdal_vrt,SOURCE_DIR>)
set_property(TARGET gcore PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})

if (GDAL_ENABLE_DRIVER_GTIFF)
  target_include_directories(gcore PRIVATE $<TARGET_PROPERTY:gdal_GTIFF,SOURCE_DIR>)
  target_compile_definitions(gcore PRIVATE -DHAVE_TIFF)
endif()

if (NOT DEFINED GDAL_RESOURCE_PATH)
  message(FATAL_ERROR "GDAL_RESOURCE_PATH not set")
endif ()
file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}/${GDAL_RESOURCE_PATH}" INST_DATA_PATH)
set_property(
  SOURCE gdaldrivermanager.cpp
  APPEND
  PROPERTY COMPILE_DEFINITIONS INST_DATA="${INST_DATA_PATH}" INSTALL_PLUGIN_FULL_DIR="${INSTALL_PLUGIN_FULL_DIR}")
if (GDAL_USE_XERCESC)
  target_include_directories(gcore PRIVATE ${XercesC_INCLUDE_DIRS} ${XercesC_INCLUDE_DIRS}/xercesc)
  set_property(
    SOURCE gdaldrivermanager.cpp
    APPEND
    PROPERTY COMPILE_DEFINITIONS HAVE_XERCES)
endif ()

option(GDAL_AUTOLOAD_PLUGINS "Set to OFF to prevent any attempt at loading plugins" ON)
mark_as_advanced(GDAL_AUTOLOAD_PLUGINS)
if (NOT GDAL_AUTOLOAD_PLUGINS)
  set_property(
    SOURCE gdaldrivermanager.cpp
    APPEND
    PROPERTY COMPILE_DEFINITIONS GDAL_NO_AUTOLOAD)
endif ()

if (GDAL_ENABLE_ARM_NEON_OPTIMIZATIONS)
  target_compile_definitions(gcore PRIVATE -DHAVE_SSSE3_AT_COMPILE_TIME -DUSE_NEON_OPTIMIZATIONS)
  target_sources(gcore PRIVATE rasterio_ssse3.cpp)
elseif (HAVE_SSSE3_AT_COMPILE_TIME)
  add_library(gcore_rasterio_ssse3 OBJECT rasterio_ssse3.cpp)
  add_dependencies(gcore_rasterio_ssse3 generate_gdal_version_h)
  target_compile_definitions(gcore_rasterio_ssse3 PRIVATE -DHAVE_SSSE3_AT_COMPILE_TIME)
  gdal_standard_includes(gcore_rasterio_ssse3)
  set_property(TARGET gcore_rasterio_ssse3 PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
  target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gcore_rasterio_ssse3>)
  set_property(
    SOURCE rasterio_ssse3.cpp
    APPEND
    PROPERTY COMPILE_FLAGS ${GDAL_SSSE3_FLAG})
endif ()

if (EMBED_RESOURCE_FILES)
    add_library(gcore_resources OBJECT embedded_resources.c)
    gdal_standard_includes(gcore_resources)
    set_property(TARGET gcore_resources PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
    target_compile_definitions(gcore PRIVATE EMBED_RESOURCE_FILES)
    target_compile_definitions(gcore_gdal_misc PRIVATE EMBED_RESOURCE_FILES)
    set_target_properties(gcore_resources PROPERTIES C_STANDARD 23)
    target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gcore_resources>)
endif()
if (USE_ONLY_EMBEDDED_RESOURCE_FILES)
    target_compile_definitions(gcore PRIVATE USE_ONLY_EMBEDDED_RESOURCE_FILES)
    target_compile_definitions(gcore_gdal_misc PRIVATE USE_ONLY_EMBEDDED_RESOURCE_FILES)
endif()

target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:gcore>)

if (GDAL_USE_JSONC_INTERNAL)
  target_include_directories(gcore PRIVATE $<TARGET_PROPERTY:libjson,SOURCE_DIR>)
endif ()

if (ENABLE_PAM)
  target_compile_definitions(gcore PRIVATE -DPAM_ENABLED)
endif ()

if (NOT GDAL_ENABLE_DRIVER_DERIVED)
  target_compile_definitions(gcore PRIVATE -DWITHOUT_DERIVED)
endif ()

if (NOT GDAL_ENABLE_DRIVER_HFA OR GDAL_ENABLE_DRIVER_HFA_PLUGIN)
  target_compile_definitions(gcore PRIVATE -DNO_HFA_SUPPORT)
endif()

add_subdirectory(mdreader)

# External libs now
if (NOT GDAL_USE_JSONC_INTERNAL)
  gdal_target_link_libraries(gcore PRIVATE ${JSONC_TARGET})
endif ()

if (NOT DEFINED OGR_ENABLE_DRIVER_SQLITE)
  message(FATAL_ERROR "OGR_ENABLE_DRIVER_SQLITE should be set to ON or OFF")
endif ()
if (OGR_ENABLE_DRIVER_SQLITE)
  target_compile_definitions(gcore PRIVATE -DSQLITE_ENABLED)
endif ()
if (GDAL_USE_LIBXML2)
  target_compile_definitions(gcore PRIVATE -DHAVE_LIBXML2)
  gdal_target_link_libraries(gcore PRIVATE LibXml2::LibXml2)

  # Some libxml2 builds may require Iconv (libxml2/libxml/encoding.h includes iconv.h if LIBXML_ICONV_ENABLED is
  # defined)
  if (GDAL_USE_ICONV)
    if (NOT Iconv_IS_BUILT_IN)
      target_include_directories(gcore PRIVATE $<TARGET_PROPERTY:Iconv::Iconv,INTERFACE_INCLUDE_DIRECTORIES>)
    endif ()
  endif ()

endif ()
if (GDAL_USE_GEOS)
  target_compile_definitions(gcore PRIVATE -DHAVE_GEOS)
  gdal_target_link_libraries(gcore PRIVATE ${GEOS_TARGET})
  target_compile_definitions(gcore_gdal_misc PRIVATE -DHAVE_GEOS)
  gdal_target_link_libraries(gcore_gdal_misc PRIVATE ${GEOS_TARGET})
endif ()

if (GDAL_USE_CURL)
  # Just for gdal_misc.cpp in fact
  target_compile_definitions(gcore_gdal_misc PRIVATE -DHAVE_CURL)
  gdal_target_link_libraries(gcore_gdal_misc PRIVATE CURL::libcurl)
endif ()

# Windows(Mingw/MSVC) link libraries
if (CMAKE_SYSTEM_NAME MATCHES "Windows")
  # psapi needed for gdalpython.cpp (EnumProcessModules)
  gdal_target_link_libraries(gcore PRIVATE psapi)
endif ()

include(TargetPublicHeader)
target_public_header(
  TARGET
  gdal
  HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/gdal_version_full/gdal_version.h
  gdal.h
  gdal_fwd.h
  gdalalgorithm.h
  gdaljp2metadata.h
  gdaljp2abstractdataset.h
  gdal_frmts.h
  gdal_pam.h
  gdal_priv.h
  gdal_proxy.h
  gdal_rat.h
  gdalcachedpixelaccessor.h
  rawdataset.h
  gdalgeorefpamdataset.h
  gdal_mdreader.h
  gdalsubdatasetinfo.h
  gdal_typetraits.h
  gdal_adbc.h
  gdal_minmax_element.hpp
  gdal_priv_templates.hpp  # Required by gdal_minmax_element.hpp
  geoheif.h
)

set(GDAL_DATA_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/data/tms_LINZAntarticaMapTileGrid.json
    ${CMAKE_CURRENT_SOURCE_DIR}/data/tms_MapML_APSTILE.json
    ${CMAKE_CURRENT_SOURCE_DIR}/data/tms_MapML_CBMTILE.json
    ${CMAKE_CURRENT_SOURCE_DIR}/data/tms_NZTM2000.json
    ${CMAKE_CURRENT_SOURCE_DIR}/data/template_tiles.mapml
)
set_property(
  TARGET ${GDAL_LIB_TARGET_NAME}
  APPEND
  PROPERTY RESOURCE "${GDAL_DATA_FILES}")

=== ogr/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

add_library(
  ogr OBJECT
  ogrgeometryfactory.cpp
  ogrpoint.cpp
  ogrcurve.cpp
  ogrlinestring.cpp
  ogrlinearring.cpp
  ogrpolygon.cpp
  ogrtriangle.cpp
  ogrutils.cpp
  ogrgeomcoordinateprecision.cpp
  ogrgeometry.cpp
  ogrgeometrycollection.cpp
  ogrmultipolygon.cpp
  ogrsurface.cpp
  ogrpolyhedralsurface.cpp
  ogrtriangulatedsurface.cpp
  ogrmultipoint.cpp
  ogrmultilinestring.cpp
  ogrcircularstring.cpp
  ogrcompoundcurve.cpp
  ogrcurvepolygon.cpp
  ogrcurvecollection.cpp
  ogrmulticurve.cpp
  ogrmultisurface.cpp
  ogr_api.cpp
  ogrfeature.cpp
  ogrfeaturedefn.cpp
  ogrfeaturequery.cpp
  ogrfeaturestyle.cpp
  ogrfielddefn.cpp
  ogrspatialreference.cpp
  ogr_srsnode.cpp
  ogr_fromepsg.cpp
  ogrct.cpp
  ogr_srs_cf1.cpp
  ogr_srs_esri.cpp
  ogr_srs_pci.cpp
  ogr_srs_usgs.cpp
  ogr_srs_dict.cpp
  ogr_srs_panorama.cpp
  ogr_srs_ozi.cpp
  ogr_srs_erm.cpp
  swq.cpp
  swq_expr_node.cpp
  swq_parser.cpp
  swq_select.cpp
  swq_op_registrar.cpp
  swq_op_general.cpp
  ogr_srs_xml.cpp
  ograssemblepolygon.cpp
  ogr2gmlgeometry.cpp
  gml2ogrgeometry.cpp
  ogr_expat.cpp
  ogrpgeogeometry.cpp
  ogr_geocoding.cpp
  ogr_schema_override.cpp
  ogrgeomfielddefn.cpp
  ograpispy.cpp
  ogr_xerces.cpp
  ogr_geo_utils.cpp
  ogr_proj_p.cpp
  ogr_wkb.cpp
  ogrvrtgeometrytypes.cpp
  ogr2kmlgeometry.cpp
  ogrlibjsonutils.cpp
  ogrgeojsongeometry.cpp
  ogrgeojsonwriter.cpp
  ogresrijsongeometry.cpp
  ogrmitabspatialref.cpp
  mitab_bounds.cpp
)
add_dependencies(ogr generate_gdal_version_h)

set(GDAL_DATA_FILES
    LICENSE.TXT
    ${CMAKE_CURRENT_SOURCE_DIR}/data/cubewerx_extra.wkt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/ecw_cs.wkt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/epsg.wkt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/esri_StatePlane_extra.wkt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/ozi_datum.csv
    ${CMAKE_CURRENT_SOURCE_DIR}/data/ozi_ellips.csv
    ${CMAKE_CURRENT_SOURCE_DIR}/data/pci_datum.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/pci_ellips.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/data/stateplane.csv
    ${CMAKE_CURRENT_SOURCE_DIR}/data/ogr_fields_override.schema.json
)
set_property(
  TARGET ${GDAL_LIB_TARGET_NAME}
  APPEND
  PROPERTY RESOURCE "${GDAL_DATA_FILES}")

include(GdalStandardIncludes)
gdal_standard_includes(ogr)
target_compile_options(ogr PRIVATE ${GDAL_CXX_WARNING_FLAGS} ${WFLAG_OLD_STYLE_CAST} ${WFLAG_EFFCXX})
set_property(TARGET ogr PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:ogr>)

target_compile_definitions(ogr PUBLIC $<$<CONFIG:DEBUG>:GDAL_DEBUG>)
if (USE_PRECOMPILED_HEADERS)
    target_precompile_headers(ogr REUSE_FROM gdal_priv_header)
endif()

if (GDAL_USE_ZLIB_INTERNAL)
  gdal_add_vendored_lib(ogr libz)
endif ()

if (GDAL_USE_JSONC_INTERNAL)
  gdal_add_vendored_lib(ogr libjson)
endif ()

gdal_target_link_libraries(ogr PRIVATE PROJ::proj)

# External libs then
if (GDAL_USE_GEOS)
  target_compile_definitions(ogr PRIVATE -DHAVE_GEOS=1)
  gdal_target_link_libraries(ogr PRIVATE ${GEOS_TARGET})
endif ()

if (GDAL_USE_SFCGAL)
  target_compile_definitions(ogr PRIVATE -DHAVE_SFCGAL=1)
  gdal_target_link_libraries(ogr PRIVATE SFCGAL::SFCGAL)
  string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" SFCGAL_VERSION_MAJOR "${SFCGAL_VERSION_STRING}")
  string(REGEX REPLACE "^[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" SFCGAL_VERSION_MINOR "${SFCGAL_VERSION_STRING}")
  string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)" "\\1" SFCGAL_VERSION_PATCH "${SFCGAL_VERSION_STRING}")
  # work around for SFCGAL 1.3.7 on Ubuntu 20.04/Debian
  if (SFCGAL_VERSION_STRING VERSION_EQUAL "1.3.7")
    if (CMAKE_SYSTEM_NAME MATCHES "Linux")
      message(
        WARNING
          "Detect SFCGAL v1.3.7 on Linux (maybe Ubuntu 20.04?), known as buggy that cause a link error. Trying a workaround"
        )
      find_library(GMPXX_LIBRARY NAMES gmpxx)
      gdal_target_link_libraries(ogr PRIVATE ${GMPXX_LIBRARY})
    endif ()
  endif ()
endif ()
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/ogr_sfcgal.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/ogr_sfcgal.h
)
target_include_directories(ogr PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

if (NOT GDAL_USE_ZLIB_INTERNAL)
  target_compile_definitions(ogr PRIVATE -DHAVE_ZLIB_H -DHAVE_ZLIB)
  if (MSVC AND NOT ZLIB_IS_STATIC)
    target_compile_definitions(ogr PRIVATE -DZLIB_DLL)
  endif ()
  gdal_target_link_libraries(ogr PRIVATE ZLIB::ZLIB)
endif ()

if (GDAL_USE_EXPAT)
  target_compile_definitions(ogr PRIVATE -DHAVE_EXPAT)
  gdal_target_link_libraries(ogr PRIVATE ${EXPAT_TARGET})
endif ()

if (GDAL_USE_XERCESC)
  target_sources(ogr PRIVATE ogr_xerces_headers.h)
  target_compile_definitions(ogr PRIVATE -DHAVE_XERCES)
  gdal_target_link_libraries(ogr PRIVATE XercesC::XercesC)
endif ()

if (NOT GDAL_USE_JSONC_INTERNAL)
  gdal_target_link_libraries(ogr PRIVATE ${JSONC_TARGET})
endif ()

include(TargetPublicHeader)
target_public_header(
  TARGET
  gdal
  HEADERS
  ogr_api.h
  ogr_recordbatch.h
  ogr_core.h
  ogr_feature.h
  ogr_featurestyle.h
  ogr_geocoding.h
  ogr_geometry.h
  ogr_geomcoordinateprecision.h
  ogr_p.h
  ogr_spatialref.h
  ogr_swq.h
  ogr_srs_api.h
  ogrsf_frmts/ogrsf_frmts.h)

###########################################################
# Targets to refresh swq_parser.cpp
###########################################################

# Those targets need to be run manually each time swq_parser.y
# is modified.
# We could of course run them automatically, but that would make building
# GDAL harder.

# This target checks that swq_parser.y md5sum has not changed
# If it has, then it should be updated and the generate_swq_parser target
# should be manually run
add_custom_target(check_swq_parser_md5 ALL
                  COMMAND ${CMAKE_COMMAND}
                      "-DIN_FILE=swq_parser.y"
                      "-DTARGET=generate_swq_parser"
                      "-DEXPECTED_MD5SUM=c3eaca734f3005e73586cc697e481f94"
                      "-DFILENAME_CMAKE=${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt"
                      -P "${PROJECT_SOURCE_DIR}/cmake/helpers/check_md5sum.cmake"
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/swq_parser.y"
                  VERBATIM)

find_package(BISON)
add_custom_target(generate_swq_parser
                  COMMAND ${CMAKE_COMMAND}
                      "-DBISON_FOUND=${BISON_FOUND}"
                      "-DBISON_EXECUTABLE=${BISON_EXECUTABLE}"
                      -P "${CMAKE_CURRENT_SOURCE_DIR}/generate_swq_parser.cmake"
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  VERBATIM)

=== port/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

include(TargetPublicHeader)
include(GdalDriverHelper)

target_public_header(
  TARGET
  gdal
  HEADERS
  cpl_atomic_ops.h
  cpl_auto_close.h
  cpl_compressor.h
  cpl_config_extras.h
  cpl_conv.h
  cpl_csv.h
  cpl_error.h
  cpl_float.h
  cpl_hash_set.h
  cpl_http.h
  cpl_json.h
  cplkeywordparser.h
  cpl_list.h
  cpl_minixml.h
  cpl_multiproc.h
  cpl_port.h
  cpl_progress.h
  cpl_quad_tree.h
  cpl_spawn.h
  cpl_string.h
  cpl_time.h
  cpl_vsi.h
  cpl_vsi_error.h
  cpl_vsi_virtual.h
  cpl_virtualmem.h
  gdal_csv.h)

set(CPL_SOURCES
    cpl_alibaba_oss.cpp
    cpl_azure.cpp
    cpl_conv.cpp
    cpl_error.cpp
    cpl_string.cpp
    cplgetsymbol.cpp
    cplstringlist.cpp
    cpl_strtod.cpp
    cpl_path.cpp
    cpl_csv.cpp
    cpl_findfile.cpp
    cpl_minixml.cpp
    cpl_multiproc.cpp
    cpl_levenshtein.cpp
    cpl_list.cpp
    cpl_getexecpath.cpp
    cplstring.cpp
    cpl_vsisimple.cpp
    cpl_vsil.cpp
    cpl_vsi_mem.cpp
    cpl_http.cpp
    cpl_hash_set.cpp
    cplkeywordparser.cpp
    cpl_recode.cpp
    cpl_recode_stub.cpp
    cpl_quad_tree.cpp
    cpl_atomic_ops.cpp
    cpl_vsil_subfile.cpp
    cpl_time.cpp
    cpl_vsil_stdout.cpp
    cpl_vsil_sparsefile.cpp
    cpl_vsil_abstract_archive.cpp
    cpl_vsil_tar.cpp
    cpl_vsil_libarchive.cpp
    cpl_vsil_stdin.cpp
    cpl_vsil_buffered_reader.cpp
    cpl_vsil_plugin.cpp
    cpl_base64.cpp
    cpl_vsil_curl.cpp
    cpl_vsil_curl_streaming.cpp
    cpl_vsil_cache.cpp
    cpl_xml_validate.cpp
    cpl_spawn.cpp
    cpl_google_oauth2.cpp
    cpl_progress.cpp
    cpl_virtualmem.cpp
    cpl_worker_thread_pool.cpp
    cpl_vsil_crypt.cpp
    cpl_sha1.cpp
    cpl_sha256.cpp
    cpl_aws.cpp
    cpl_aws_win32.cpp
    cpl_vsi_error.cpp
    cpl_cpu_features.cpp
    cpl_google_cloud.cpp
    cpl_json.cpp
    cpl_json_streaming_parser.cpp
    cpl_md5.cpp
    cpl_vsil_hdfs.cpp
    cpl_swift.cpp
    cpl_vsil_adls.cpp
    cpl_vsil_az.cpp
    cpl_vsil_chunked_write_handle.cpp
    cpl_vsil_uploadonclose.cpp
    cpl_vsil_gs.cpp
    cpl_vsil_webhdfs.cpp
    cpl_vsil_s3.cpp
    cpl_vsil_oss.cpp
    cpl_vsil_swift.cpp
    cpl_json_streaming_writer.cpp
    cpl_userfaultfd.cpp
    cpl_vax.cpp
    cpl_compressor.cpp
    cpl_float.cpp)
add_library(cpl OBJECT ${CPL_SOURCES})
target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:cpl>)
target_compile_options(cpl PRIVATE ${GDAL_CXX_WARNING_FLAGS} ${WFLAG_OLD_STYLE_CAST} ${WFLAG_EFFCXX})
set_property(TARGET cpl PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})

set_property(SOURCE cpl_path.cpp PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)

# include path to generated cpl_config.h
target_include_directories(cpl PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

if ((EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cpl_config.h") AND NOT ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL
                                                                 "${CMAKE_CURRENT_BINARY_DIR}"))
  # Try to detect issues when building with cmake out of source tree, but against a previous build done in source tree
  message(
    FATAL_ERROR
      "${CMAKE_CURRENT_SOURCE_DIR}/cpl_config.h was found, and likely conflicts with ${CMAKE_CURRENT_BINARY_DIR}/cpl_config.h"
    )
endif ()

file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}/${GDAL_RESOURCE_PATH}" INST_DATA_PATH)
target_compile_definitions(cpl PRIVATE INST_DATA="${INST_DATA_PATH}")

if(CMAKE_INSTALL_FULL_SYSCONFDIR)
    target_compile_definitions(cpl PRIVATE SYSCONFDIR="${CMAKE_INSTALL_FULL_SYSCONFDIR}")
endif()

if (WIN32)
  target_sources(cpl PRIVATE cpl_vsil_win32.cpp)
else ()
  target_sources(cpl PRIVATE cpl_vsil_unix_stdio_64.cpp)
  if ("${CMAKE_SYSTEM}" MATCHES "Linux")
      check_include_file("linux/fs.h" HAVE_LINUX_FS_H)
      if (NOT HAVE_LINUX_FS_H)
          set(ACCEPT_MISSING_LINUX_FS_HEADER OFF CACHE BOOL "Build despite missing linux/fs.h header.")
          mark_as_advanced(ACCEPT_MISSING_LINUX_FS_HEADER)
          if (NOT ACCEPT_MISSING_LINUX_FS_HEADER)
              message(FATAL_ERROR "linux/fs.h header not found. Impact will be lack of sparse file detection. Define the ACCEPT_MISSING_LINUX_FS_HEADER:BOOL=ON CMake variable if you want to build despite this limitation.")
          endif()
          target_compile_definitions(cpl PRIVATE -DMISSING_LINUX_FS_H)
      endif()
  endif()
  if(HAVE_PREAD64)
      target_compile_definitions(cpl PRIVATE -DHAVE_PREAD64)
  elseif(HAVE_PREAD_BSD)
      target_compile_definitions(cpl PRIVATE -DHAVE_PREAD_BSD -DSIZEOF_OFF_T=${SIZEOF_OFF_T})
  endif()
  set(BUILD_WITHOUT_64BIT_OFFSET OFF CACHE BOOL "Build GDAL without > 4GB file support. If file API does not seem to support 64-bit offset.")
  mark_as_advanced(BUILD_WITHOUT_64BIT_OFFSET)
  if(BUILD_WITHOUT_64BIT_OFFSET)
      target_compile_definitions(cpl PRIVATE -DBUILD_WITHOUT_64BIT_OFFSET)
  endif()
endif ()

if (HAVE_SSSE3_AT_COMPILE_TIME)
  target_compile_definitions(cpl PRIVATE -DHAVE_SSSE3_AT_COMPILE_TIME)
endif ()
if (HAVE_AVX_AT_COMPILE_TIME)
  target_compile_definitions(cpl PRIVATE -DHAVE_AVX_AT_COMPILE_TIME)
endif ()

if (NOT WIN32 AND CMAKE_DL_LIBS)
  gdal_target_link_libraries(cpl PRIVATE ${CMAKE_DL_LIBS})
endif ()

# Internal libraries first
if (GDAL_USE_JSONC_INTERNAL)
  gdal_add_vendored_lib(cpl libjson)
endif ()

target_compile_definitions(cpl PRIVATE -DHAVE_LIBZ -DZIP_SUPPORT)
target_sources(cpl PRIVATE cpl_vsil_gzip.cpp cpl_minizip_ioapi.cpp cpl_minizip_unzip.cpp cpl_minizip_zip.cpp)

if (GDAL_USE_ZLIB_INTERNAL)
  gdal_add_vendored_lib(cpl libz)
endif ()
if (ENABLE_DEFLATE64)
  gdal_add_vendored_lib(cpl infback9)
  target_compile_definitions(cpl PRIVATE -DENABLE_DEFLATE64)
endif ()

# Now external libraries
if (NOT GDAL_USE_JSONC_INTERNAL)
  gdal_target_link_libraries(cpl PRIVATE ${JSONC_TARGET})
endif ()

if (NOT GDAL_USE_ZLIB_INTERNAL)
  target_compile_definitions(cpl PRIVATE -DHAVE_ZLIB_H -DHAVE_ZLIB)
  if (MSVC AND NOT ZLIB_IS_STATIC)
    target_compile_definitions(cpl PRIVATE -DZLIB_DLL)
  endif ()
  gdal_target_link_libraries(cpl PRIVATE ZLIB::ZLIB)
endif ()

if (GDAL_USE_ARCHIVE)
  target_compile_definitions(cpl PRIVATE -DHAVE_LIBARCHIVE)
  gdal_target_link_libraries(cpl PRIVATE ARCHIVE::ARCHIVE)
endif ()

if (GDAL_USE_CURL)
  target_compile_definitions(cpl PRIVATE -DHAVE_CURL)
  gdal_target_link_libraries(cpl PRIVATE CURL::libcurl)
endif ()

if (GDAL_USE_ICONV)
  target_compile_definitions(cpl PRIVATE -DHAVE_ICONV)

  # Create a dedicated object library for Linux CondaForge builds, that could otherwise accidentally include libiconv
  # header file (that would have define iconv_open libiconv_open) whereas linking to system iconv.
  add_library(cpl_iconv OBJECT cpl_recode_iconv.cpp)
  target_sources(${GDAL_LIB_TARGET_NAME} PRIVATE $<TARGET_OBJECTS:cpl_iconv>)
  target_compile_options(cpl_iconv PRIVATE ${GDAL_CXX_WARNING_FLAGS} ${WFLAG_OLD_STYLE_CAST} ${WFLAG_EFFCXX})
  set_property(TARGET cpl_iconv PROPERTY POSITION_INDEPENDENT_CODE ${GDAL_OBJECT_LIBRARIES_POSITION_INDEPENDENT_CODE})
  target_compile_definitions(cpl_iconv PRIVATE -DHAVE_ICONV)
  # include path to generated cpl_config.h
  target_include_directories(cpl_iconv PRIVATE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

  if (NOT Iconv_IS_BUILT_IN)
    if (APPLE)
      # linkage against OSX's system iconv is going to require LIBICONV_PLUG to be defined, but other self-built
      # situations like CondaForge or Homebrew might not need this
      set(CMAKE_REQUIRED_LIBRARIES ${Iconv_LIBRARY})
      check_symbol_exists(_iconv_close "iconv.h" HAVE_ICONV_CLOSE)
      if (HAVE_ICONV_CLOSE)
        target_compile_definitions(cpl_iconv PRIVATE -DLIBICONV_PLUG)
      endif (HAVE_ICONV_CLOSE)
    endif (APPLE)
    gdal_target_link_libraries(cpl_iconv PRIVATE Iconv::Iconv)
  endif ()
endif ()

if (GDAL_USE_ODBC)
  target_sources(cpl PRIVATE cpl_odbc.cpp)
  target_public_header(TARGET gdal HEADERS cpl_odbc.h)
  gdal_target_link_libraries(cpl PRIVATE ODBC::ODBC)
  if (TARGET ODBC::ODBCINST)
    gdal_target_link_libraries(cpl PRIVATE ODBC::ODBCINST)
  endif ()
endif ()

if (NOT MSVC)
  if (Threads_FOUND)
    gdal_target_link_libraries(cpl PRIVATE Threads::Threads)
  endif ()
endif ()

if (HAVE_USERFAULTFD_H)
  target_compile_definitions(cpl PRIVATE -DENABLE_UFFD)
endif ()

# for plugin DLFCN: for win32 https://github.com/dlfcn-win32/dlfcn-win32/archive/v1.1.1.tar.gz if(WIN32)
# find_package(dlfcn- win32 REQUIRED) set(CMAKE_DL_LIBS dlfcn-win32::dl) endif()

if (GDAL_USE_LIBXML2)
  target_compile_definitions(cpl PRIVATE -DHAVE_LIBXML2)
  gdal_target_link_libraries(cpl PRIVATE LibXml2::LibXml2)
endif ()

if (GDAL_USE_CRYPTOPP)
  target_compile_definitions(cpl PRIVATE -DHAVE_CRYPTOPP)
  gdal_target_link_libraries(cpl PRIVATE CRYPTOPP::CRYPTOPP)
endif ()

if (GDAL_USE_OPENSSL
    AND TARGET OpenSSL::Crypto
    AND TARGET OpenSSL::SSL)
  target_compile_definitions(cpl PRIVATE -DHAVE_OPENSSL_CRYPTO)
  gdal_target_link_libraries(cpl PRIVATE OpenSSL::Crypto OpenSSL::SSL)
  if (WIN32)
    gdal_target_link_libraries(cpl PRIVATE crypt32)
  endif ()
endif ()

if (CRYPTOPP_USE_ONLY_CRYPTODLL_ALG)
  # Define USE_ONLY_CRYPTODLL_ALG is running against cryptopp.dll, but not if statically linking
  target_compile_definitions(cpl PRIVATE -DUSE_ONLY_CRYPTODLL_ALG)
endif ()

if (GDAL_USE_ZSTD)
  target_compile_definitions(cpl PRIVATE -DHAVE_ZSTD)
  gdal_target_link_libraries(cpl PRIVATE ${ZSTD_TARGET})
endif ()

if (GDAL_USE_LIBLZMA)
  target_compile_definitions(cpl PRIVATE -DHAVE_LZMA)
  gdal_target_link_libraries(cpl PRIVATE LibLZMA::LibLZMA)
endif ()

if (GDAL_USE_DEFLATE)
  target_compile_definitions(cpl PRIVATE -DHAVE_LIBDEFLATE)
  gdal_target_link_libraries(cpl PRIVATE Deflate::Deflate)
endif ()

if (GDAL_USE_LZ4)
  target_compile_definitions(cpl PRIVATE -DHAVE_LZ4)
  gdal_target_link_libraries(cpl PRIVATE LZ4::LZ4)
endif ()

if (GDAL_USE_BLOSC)
  include(CheckSymbolExists)
  cmake_push_check_state(RESET)
  set(CMAKE_REQUIRED_INCLUDES ${BLOSC_INCLUDE_DIRS})
  set(CMAKE_REQUIRED_LIBRARIES ${BLOSC_LIBRARIES})
  check_symbol_exists(blosc_cbuffer_validate blosc.h BLOSC_HAS_BLOSC_CBUFFER_VALIDATE)
  cmake_pop_check_state()
  if (BLOSC_HAS_BLOSC_CBUFFER_VALIDATE)
    target_compile_definitions(cpl PRIVATE -DHAVE_BLOSC)
    gdal_target_link_libraries(cpl PRIVATE Blosc::Blosc)
  else()
    message(STATUS "libblosc cannot be used as it lacks blosc_cbuffer_validate()")
  endif()
endif ()

if (GDAL_USE_HDFS)
  target_compile_definitions(cpl PRIVATE -DHDFS_ENABLED)
  gdal_target_link_libraries(cpl PRIVATE HDFS::HDFS)
  if (JNI_FOUND)
    gdal_target_link_libraries(cpl PRIVATE HDFS::JVM)
  endif ()
endif ()

if (MSVC)
  # needed for cpl_aws_win32
  gdal_target_link_libraries(cpl PRIVATE wbemuuid)
endif ()

if (NOT CMAKE_CROSSCOMPILING AND BUILD_VSIPRELOAD AND "${CMAKE_SYSTEM}" MATCHES "Linux" AND ${BUILD_SHARED_LIBS})
  option(BUILD_VSIPRELOAD "Build vsipreload.so" ON)
  mark_as_advanced(BUILD_VSIPRELOAD)
  if(BUILD_VSIPRELOAD)
    add_library(vsipreload MODULE vsipreload.cpp)
    set_target_properties(vsipreload PROPERTIES PREFIX "")
    target_link_libraries(vsipreload PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}> ${CMAKE_DL_LIBS})
    set_property(SOURCE vsipreload.cpp PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)

    # For musl / Alpine
    foreach(_header IN ITEMS stdio.h fcntl.h unistd.h dirent.h sys/stat.h)
      if(EXISTS "/usr/include/${_header}")
        file(READ "/usr/include/${_header}" _content)
        if("${_content}" MATCHES "#define fopen64 fopen")
          target_compile_definitions(vsipreload PRIVATE FOPEN64_ALIAS_OF_FOPEN)
        endif()
        if("${_content}" MATCHES "#define fseeko64 fseeko")
          target_compile_definitions(vsipreload PRIVATE FSEEKO64_ALIAS_OF_FSEEKO)
        endif()
        if("${_content}" MATCHES "#define ftello64 ftello")
          target_compile_definitions(vsipreload PRIVATE FTELLO64_ALIAS_OF_FTELLO)
        endif()

=== swig/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

set(GDAL_SWIG_COMMON_INTERFACE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Algorithm.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Band.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/ColorTable.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/cpl.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/cpl_exceptions.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/cplvirtualmem.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Dataset.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Driver.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/gdal.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/gdal_array.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/gdal_typemaps.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/gnm.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/MajorObject.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/ogr.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/ogr_error_map.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Operations.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/osr.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/RasterAttributeTable.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Relationship.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/SubdatasetInfo.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/Transform.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/XMLNode.i
    ${CMAKE_CURRENT_SOURCE_DIR}/include/MultiDimensional.i)

# BUILD_PYTHON_BINDINGS is already defined in ../CMakeLists.txt

if (BUILD_PYTHON_BINDINGS)
  add_subdirectory(python)
endif ()

# Java bindings
if (SWIG_EXECUTABLE
    AND Java_JAVAC_EXECUTABLE
    AND JNI_FOUND
    AND ANT)
    option(BUILD_JAVA_BINDINGS "Build Java bindings" ON)
else()
    option(BUILD_JAVA_BINDINGS "Build Java bindings" OFF)
endif()

if (BUILD_JAVA_BINDINGS)
    if (NOT SWIG_FOUND)
        message(FATAL_ERROR "SWIG is a requirement to build the Java bindings")
    endif()
    if (NOT Java_JAVAC_EXECUTABLE)
        message(FATAL_ERROR "javac is a requirement to build the Java bindings")
    endif()
    if (NOT JNI_FOUND)
        message(FATAL_ERROR "JNI is a requirement to build the Java bindings")
    endif()
    if (NOT ANT)
        message(FATAL_ERROR "ant is a requirement to build the Java bindings")
    endif()
    add_subdirectory(java)
endif()

# CSharp bindings

if (SWIG_EXECUTABLE AND CSHARP_FOUND)
    option(BUILD_CSHARP_BINDINGS "Build CSharp bindings" ON)
else()
    option(BUILD_CSHARP_BINDINGS "Build CSharp bindings" OFF)
endif ()

option(BUILD_CSHARP_BINDINGS "Build CSharp bindings" ON)

if (BUILD_CSHARP_BINDINGS)
    if (NOT SWIG_FOUND)
        message(FATAL_ERROR "SWIG is a requirement to build the CSharp bindings")
    endif()
    if (NOT CSHARP_FOUND)
        message(FATAL_ERROR "A CSharp/DotNet compiler is a requirement to build the CSharp bindings")
    endif()
    add_subdirectory(csharp)
endif ()

=== frmts/aaigrid/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt.

# it provides AAIGrid and GRASSASCIIGrid
add_gdal_driver(
  TARGET gdal_AAIGrid
  SOURCES aaigriddataset.cpp aaigriddataset.h
  BUILTIN)
gdal_standard_includes(gdal_AAIGrid)

=== frmts/adrg/CMakeLists.txt ===
# CMake4GDAL project is distributed under MIT license. See accompanying file LICENSE.txt. There are gdal_ADRG and
# gdal_SRP driver
add_gdal_driver(
  TARGET gdal_ADRG
  SOURCES adrgdataset.cpp srpdataset.cpp
  BUILTIN)
gdal_standard_includes(gdal_ADRG)
target_include_directories(gdal_ADRG PRIVATE $<TARGET_PROPERTY:gdal_iso8211,SOURCE_DIR>)

=== frmts/avif/CMakeLists.txt ===
include("${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/helpers/GdalCMakeMinimumRequired.cmake")
cmake_minimum_required(VERSION ${GDAL_CMAKE_VERSION_MIN}...${GDAL_CMAKE_VERSION_MAX})

if(NOT DEFINED PROJECT_SOURCE_DIR)
    # Standalone plugin building
    project(gdal_AVIF)
    set(STRICT_VERSION_CHECK ON)
    include("${PROJECT_SOURCE_DIR}/../../cmake/helpers/SetupStandalonePlugin.cmake" )
    include(CheckDependentLibrariesAVIF)
    standalone_driver_finalize(GDAL_ENABLE_DRIVER_AVIF)
endif()

add_gdal_driver(TARGET gdal_AVIF
                SOURCES avifdataset.cpp
                CORE_SOURCES avifdrivercore.cpp
                PLUGIN_CAPABLE
                NO_SHARED_SYMBOL_WITH_CORE
                STRONG_CXX_WFLAGS)

if(NOT TARGET gdal_AVIF)
    return()
endif()

gdal_standard_includes(gdal_AVIF)
gdal_target_link_libraries(gdal_AVIF PRIVATE AVIF::AVIF)

=== frmts/basisu_ktx2/CMakeLists.txt ===
add_gdal_driver(TARGET gdal_BASISU_KTX2
                SOURCES
                    basisudataset.cpp
                    ktx2dataset.cpp
                    common.cpp
                CORE_SOURCES
                    basisudrivercore.cpp
                    ktx2drivercore.cpp
                    commoncore.cpp
                STRONG_CXX_WFLAGS
                PLUGIN_CAPABLE
                NO_SHARED_SYMBOL_WITH_CORE)

if(NOT TARGET gdal_BASISU_KTX2)
    return()
endif()

gdal_standard_includes(gdal_BASISU_KTX2)
gdal_target_link_libraries(gdal_BASISU_KTX2 PRIVATE basisu::basisu_lib)

=== frmts/bsb/CMakeLists.txt ===
add_gdal_driver(TARGET gdal_BSB SOURCES bsb_read.h bsb_read.c bsbdataset.cpp PLUGIN_CAPABLE NO_DEPS)
gdal_standard_includes(gdal_BSB)

if (NOT GDAL_ENABLE_DRIVER_BSB_PLUGIN)
  add_executable(bsb2raw EXCLUDE_FROM_ALL bsb2raw.c)
  target_include_directories(bsb2raw PRIVATE $<TARGET_PROPERTY:gdal_BSB,SOURCE_DIR>)
  target_link_libraries(bsb2raw PRIVATE $<TARGET_NAME:${GDAL_LIB_TARGET_NAME}> gdal_BSB)
endif ()

=== frmts/cals/CMakeLists.txt ===
add_gdal_driver(TARGET gdal_CALS SOURCES calsdataset.cpp PLUGIN_CAPABLE NO_DEPS)
gdal_standard_includes(gdal_CALS)

if (GDAL_USE_TIFF_INTERNAL)
  target_include_directories(gdal_CALS PRIVATE $<TARGET_PROPERTY:libtiff,SOURCE_DIR>)
else ()
  target_include_directories(gdal_CALS PRIVATE ${TIFF_INCLUDE_DIRS})
endif ()

=== frmts/ceos2/CMakeLists.txt ===
add_gdal_driver(
  TARGET gdal_SAR_CEOS
  DEF FRMT_ceos2
  SOURCES ceos.c
          ceos.h
          ceosrecipe.c
          ceossar.c
          link.c
          sar_ceosdataset.cpp
          PLUGIN_CAPABLE
          NO_DEPS)
gdal_standard_includes(gdal_SAR_CEOS)
target_include_directories(gdal_SAR_CEOS PRIVATE $<TARGET_PROPERTY:gdal_raw,SOURCE_DIR>)

=== debian/changelog ===
gdal (3.11.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.
  * Update lintian overrides.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 11 Sep 2025 11:54:18 +0200

=== debian/control ===
Source: gdal
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               dh-sequence-numpy3,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-python3,
               doxygen,
               graphviz,
               chrpath,
               bash-completion,
               libarchive-dev,
               libarmadillo-dev,
               libavif-dev,
               libblosc-dev,
               libcfitsio-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libdeflate-dev,
               libexpat1-dev,
               libexprtk-dev,
               libfreexl-dev (>= 1.0.0),
               libfyba-dev,
               libgeos-dev,
               libgeotiff-dev (>= 1.5.0),
               libgif-dev,
               libhdf4-dev,
               libhdf5-dev (>= 1.8.8),
               libheif-dev,
               libjpeg-dev,
               libjson-c-dev,
               libjxl-dev,
               libkml-dev (>= 1.3.0~rc0-3),
               liblz4-dev,
               liblzma-dev,
               libmuparser-dev,
       default-libmysqlclient-dev,
               libnetcdf-dev (>= 1:4.0.0),
               libopenjp2-7-dev,
               libpcre2-dev,
               libpng-dev,
               libpoppler-private-dev,
               libpq-dev,
               libproj-dev (>= 6.0.0),
               libqhull-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libtiff-dev,
               liburiparser-dev,
               libwebp-dev,
               libxerces-c-dev,
               libxml2-dev,
               libzstd-dev,
               netcdf-bin,
               patch,
               pkgconf,
               pkg-kde-tools,
               python3-all-dev,
               python3-numpy,
               python3-setuptools,
               swig,
               unixodbc-dev (>= 2.2.11),
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-gis-team/gdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/gdal.git
Homepage: http://www.gdal.org/
Rules-Requires-Root: no

Package: libgdal37
Architecture: any
Multi-Arch: same
Section: libs
Depends: gdal-data (>= ${source:Version}),
         gdal-plugins (>= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: proj-bin
Description: Geospatial Data Abstraction Library
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports many popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the shared library.

Package: libgdal-dev
Architecture: any
Section: libdevel
Depends: libgdal37 (= ${binary:Version}),
         libarchive-dev,
         libarmadillo-dev,
         libavif-dev,
         libblosc-dev,
         libc6-dev,
         libcfitsio-dev,
         libcurl4-gnutls-dev | libcurl-ssl-dev,
         libdeflate-dev,
         libexpat1-dev,
         libexprtk-dev,
         libfreexl-dev,
         libfyba-dev,
         libgeos-dev,
         libgeotiff-dev (>= 1.5.0),
         libgif-dev,
         libhdf4-dev,
         libhdf5-dev,
         libheif-dev,
         libjpeg-dev,
         libjson-c-dev,
         libjxl-dev,
         libkml-dev,
         libltdl-dev,
         liblz4-dev,
         liblzma-dev,
         libmuparser-dev,
 default-libmysqlclient-dev,
         libnetcdf-dev,
         libopenjp2-7-dev,
         libpcre2-dev,
         libpng-dev,
         libpoppler-private-dev,
         libpq-dev,
         libproj-dev (>= 6.0.0),
         libqhull-dev,
         libspatialite-dev,
         libsqlite3-dev,
         libtiff-dev,
         liburiparser-dev,
         libwebp-dev,
         libxerces-c-dev,
         libxml2-dev,
         libzstd-dev,
         unixodbc-dev,
         ${misc:Depends}
Description: Geospatial Data Abstraction Library - Development files
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports many popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the files needed to develop a software that
 will use the GDAL/OGR (headers, static objects, configuration script).

Package: gdal-bin
Architecture: any
Multi-Arch: foreign
Depends: python3-gdal (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: libgdal-grass
Breaks: gdal-bin (<< 1.10.0-0~),
        python-gdal (<< 2.4.3~)
Replaces: python-gdal (<< 2.4.3~)
Description: Geospatial Data Abstraction Library - Utility programs
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains utility programs, based on GDAL/OGR library,
 namely gdal_translate, gdalinfo, gdaladdo, gdalwarp, ogr2ogr, ogrinfo,
 ogrtindex.

Package: gdal-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Geospatial Data Abstraction Library - Data files
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains the GDAL data files.

Package: gdal-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: Geospatial Data Abstraction Library - Plugins
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains data for the plugins.

Package: python3-gdal
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: gdal-bin
Description: Python 3 bindings to the Geospatial Data Abstraction Library
 GDAL is a translator library for raster geospatial data formats.
 As a library, it presents a single abstract data model to the
 calling application for all supported formats. The related OGR
 library (which lives within the GDAL source tree) provides
 a similar capability for simple features vector data.
 .
 GDAL supports 40+ popular data formats, including commonly used
 ones (GeoTIFF, JPEG, PNG and more) as well as the ones used in
 GIS and remote sensing software packages (ERDAS Imagine,
 ESRI Arc/Info, ENVI, PCI Geomatics). Also supported many remote
 sensing and scientific data distribution formats such as HDF,
 EOS FAST, NOAA L1B, NetCDF, FITS.
 .
 OGR library supports popular vector formats like ESRI Shapefile,
 TIGER data, S57, MapInfo File, DGN, GML and more.
 .
 This package contains Python 3 bindings for the GDAL/OGR library.
